/*
 *
 * Copyright (C) 2004-2006 Mekensleep
 *
 *	Mekensleep
 *	24 rue vieille du temple
 *	75004 Paris
 *       licensing@mekensleep.com
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Authors:
 *  Cedric PINSON <cpinson@freesheep.org>
 *  Bruno 'Beosil' Heidelberger
 *  Loic Dachary <loic@gnu.org>
 *  Igor Kravtchenko <igor@ozos.net>
 *
 */

#ifndef CAL_BLENDER_H
#define CAL_BLENDER_H

#include "ucal3d_export.h"
#include <cal3d/global.h>

class CalAnimationAlt;
class CalModel;
class CalSkeleton;

class CalBlender
{
public:
  enum Channel {
    FOREGROUND=0,
    BACKGROUND=1,
  };

private:
  CalModel *m_pModel;

  typedef std::list<CalAnimationAlt*> Animations;
  Animations m_animationBackground;
  Animations m_animationForeground;

  float m_animationTime;
  float m_animationDuration;

  void updateChannel(Animations &animations, CalSkeleton *pSkeleton);
public:

  CalBlender();
  virtual ~CalBlender();

  bool addAnimation(Channel channel, CalAnimationAlt* pAnimation);
  void removeAnimation(CalAnimationAlt* pAnimation);

  Animations& getForegroundList() { return m_animationForeground; }
  Animations& getBackgroundList() { return m_animationBackground; }

  void update();
  
  bool create(CalModel *pModel);
  void destroy();
};

#endif 
