/*
*
* Copyright (C) 2004-2006 Mekensleep
*
*	Mekensleep
*	24 rue vieille du temple
*	75004 Paris
*       licensing@mekensleep.com
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*
* Authors:
*  Johan Euphrosine <johan@mekensleep.com>
*
*/

#ifndef __POKER_SELECTION_CONTROLLER__
#define __POKER_SELECTION_CONTROLLER__

#ifndef POKER_USE_VS_PCH
#include <ugame/artefact.h>
#endif

class PokerApplication;

class PokerSelectableController : public UGAMEArtefactController
{
 public:
  PokerSelectableController(unsigned int id=0);
  virtual ~PokerSelectableController();
  virtual void Init(PokerApplication* game);
  virtual bool Update(MAFApplication* application);
  PokerApplication* mGame;
  SDL_Event* mLastEvent;
  int mX;
  int mY;
  int mMouseButtonState;
  int mXSelected;
  int mYSelected;
  bool mSelected;
  bool mMouseButtonDownEvent;
  bool mMouseButtonUpEvent;
  bool mFocused;
  bool mClickedAndFocused;
  bool mReleasedAndFocused;
  int  mUpdateCount;
  void BeginUpdateEvent();
  void UpdateEvent();
  void EndUpdateEvent();
  void UpdateView();
  static void SetNodeSelectable(osg::Node* node);
};

#endif //__POKER_SELECTION_CONTROLLER____
