/*
 *
 * Copyright (C) 2004-2006 Mekensleep
 *
 *	Mekensleep
 *	24 rue vieille du temple
 *	75004 Paris
 *       licensing@mekensleep.com
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Authors:
 *  Loic Dachary <loic@gnu.org>
 *  Igor Kravtchenko <igor@tsarevitch.org>
 *
 */

#ifndef _pokersplashscreen_h
#define _pokersplashscreen_h

#ifndef POKER_USE_VS_PCH
#include <maf/monitor.h>
#include <maf/vision.h>
#include <maf/utils.h>

#include <ugame/text.h>
#endif

#include "pokerexport.h"

class PokerApplication;

class POKER_EXPORT PokerSplashScreenModel : public MAFVisionModel, public MAFMonitor
{
 public:
  PokerSplashScreenModel(PokerApplication* application);
  virtual ~PokerSplashScreenModel();

	virtual void write(const char *);
	virtual void setProgressLength(int len);
	virtual void progress();

	void updateProgressBar();

	int len_;
	float pos_;
	double lastTime_;

	osg::ref_ptr<osg::Group> screenGroup_;
	osg::ref_ptr<MAF_OSGQuad> backGround_;
	osg::ref_ptr<MAF_OSGQuad> progressBk_;

	osg::ref_ptr<osgText::Font> font_;
	osg::ref_ptr<UGAMEBasicText> text_;
	osg::ref_ptr<osg::MatrixTransform> fontMatrix_;

	PokerApplication *application_;
};

class PokerSplashScreenController : public MAFVisionController
{
 public:
  PokerSplashScreenController(PokerApplication* application);
  virtual ~PokerSplashScreenController();

	virtual const char* GetControllerName() const { return "PokerSplashScreenController"; }

  PokerSplashScreenModel* GetModel() { return dynamic_cast<PokerSplashScreenModel*>(MAFVisionController::GetModel()); }

  inline virtual bool Update(PokerApplication* application);
};

#endif // _pokersplashscreen_h
