/*
 *
 * Copyright (C) 2004-2006 Mekensleep
 *
 *	Mekensleep
 *	24 rue vieille du temple
 *	75004 Paris
 *       licensing@mekensleep.com
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Authors:
 *  Igor Kravtchenko <igor@tsarevitch.org>
 *
 */

#ifndef maf_renderbin_h 
#define maf_renderbin_h

#ifndef MAF_USE_VS_PCH
#include <string>
#include <map>
#include <maf/mafexport.h>
struct _xmlDoc;
namespace osg { class StateSet; };
#endif

class MAFRenderBin {
public:
	MAF_EXPORT static MAFRenderBin& Instance();

	MAF_EXPORT void Read(struct _xmlDoc *_doc, const std::string &_xpath);

	MAF_EXPORT bool SetupRenderBin(const std::string &_entityName, osg::StateSet *_ss) const;
	MAF_EXPORT bool GetRenderBinIndexOfEntity(const std::string &_entityName, int &_rbinIndex) const;
	MAF_EXPORT bool GetRenderBinNameOfEntity(const std::string &_entityName, std::string &_rbinName) const;

protected:
	std::map<std::string, std::pair<int, std::string> > mName2rbin;
};

#endif // maf_renderbin_h
