/*
*
* Copyright (C) 2004-2006 Mekensleep
*
*	Mekensleep
*	24 rue vieille du temple
*	75004 Paris
*       licensing@mekensleep.com
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*
* Authors:
*  Igor Kravtchenko <igor@obraz.net>
*
*/

#ifndef MAF_SHADER_MOSAIC_H
#define MAF_SHADER_MOSAIC_H

#ifndef MAF_USE_VS_PCH
#include <maf/shader.h>
#endif

namespace osg { class Image; }

class MAFShaderMosaic : public MAFShader {

	typedef MAFShader Parent;

private:
	MAFShaderMosaic();

public:
	virtual ~MAFShaderMosaic();

	MAF_EXPORT osg::Texture1D *getUVTexture() const { return uvTexture_; }
	MAF_EXPORT void calculateUVTexture(int step);

	MAF_EXPORT void writeProgramToDisk(const char *vertex_file, const char *fragment_file);

	MAF_EXPORT virtual void configureStateSet(osg::StateSet &);

protected:

	osg::Texture1D *uvTexture_;
	osg::Image *uvImage_;

	friend class MAFShader;
};

#endif
