/*
 *
 * Copyright (C) 2004-2006 Mekensleep
 *
 *	Mekensleep
 *	24 rue vieille du temple
 *	75004 Paris
 *       licensing@mekensleep.com
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Authors:
 *  Loic Dachary <loic@gnu.org>
 *
 */

#ifndef maf_view_h 
#define maf_view_h

#ifndef MAF_USE_VS_PCH
#include <maf/mafexport.h>
#endif

#include <maf/model.h>

class MAFController;
class MAFWindow;

class MAF_EXPORT MAFView
{
public:
  MAFView() : mModel(0), mController(0), mModified(0){}
  virtual ~MAFView() {}

  inline virtual void Init( void ) {}

  inline virtual void SetModel(MAFModel* model) { mModel = model; }
  inline MAFModel* GetModel( void ) { return mModel; }

  inline virtual void SetController(MAFController* controller) { mController = controller; }
  inline MAFController* GetController( void ) { return mController; }

  inline virtual void Update(MAFWindow *) {}

  inline void SetModified(void) { mModified = SDL_GetTicks(); }
  inline Uint32 GetModified(void) { return mModified; }

protected:
  MAFModel*      mModel;
  MAFController* mController;
  Uint32         mModified;
};

#endif // maf_view_h
