/*
 *
 * Copyright (C) 2004-2006 Mekensleep
 *
 *	Mekensleep
 *	24 rue vieille du temple
 *	75004 Paris
 *       licensing@mekensleep.com
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Authors:
 *  Loic Dachary <loic@gnu.org>
 *
 */

#ifndef ugame_error_h
#define ugame_error_h

#include <maf/maferror.h>
#include <ugame/ugameexport.h>

#define UNDERWARE_UGAME_ERROR underware_ugame_error_quark()

GQuark underware_ugame_error_quark(void);

typedef enum {
  UNDERWARE_UGAME_ERROR_FAILED, // Generic
  UNDERWARE_UGAME_ERROR_MODEL
} UnderwareUgameError;

class UGAME_EXPORT UGAMEError  : public MAFError {
public:
  UGAMEError(GError* error);
  UGAMEError(gint code, const gchar* format, ...);
  UGAMEError(GQuark domain, gint code, const gchar* format, ...);
  virtual ~UGAMEError();
};

#endif // ugame_error_h
