/*
 *
 * Copyright (C) 2006 Mekensleep
 *
 *	Mekensleep
 *	24 rue vieille du temple
 *	75004 Paris
 *       licensing@mekensleep.com
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Authors:
 *  Igor Kravtchenko <igor@tsarevitch.org>
 *
 */

#ifndef UNDERWARE_VSERIAL_FLAGABLE_H
#define UNDERWARE_VSERIAL_FLAGABLE_H

#ifndef UNDERWARE_VSERIAL_USE_PCH
#include <vserial/vserial.h>
#endif

ENTER_NAMESPACE_UNDERWARE

class Flagable {
public:

	Flagable() : flags_(0) { };
	~Flagable() { };

	UW_VSERIAL_API inline int getFlags() const { return flags_; }
	UW_VSERIAL_API inline void setFlag(int _flag) { flags_ |= _flag; }
	UW_VSERIAL_API inline void setFlags(int _flags) { flags_ = _flags; }
	UW_VSERIAL_API inline void removeFlag(int _flag) { flags_ &= ~_flag; }

protected:
	int flags_;
};

LEAVE_NAMESPACE

#endif // UNDERWARE_VSERIAL_FLAGABLE_H
