/*
 *
 * Copyright (C) 2006 Mekensleep
 *
 *	Mekensleep
 *	24 rue vieille du temple
 *	75004 Paris
 *       licensing@mekensleep.com
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Authors:
 *  Igor Kravtchenko <igor@tsarevitch.org>
 *
 */

#ifndef UNDERWARE_VSERIAL_KEYFRAME_H
#define UNDERWARE_VSERIAL_KEYFRAME_H

#ifndef UNDERWARE_VSERIAL_USE_PCH
#include <vserial/vserial.h>
#endif

#include <vserial/quat.h>

ENTER_NAMESPACE_UNDERWARE

class KeyBase {
public:

	enum SHAPE {
		SHAPE_TCB	= 0,
		SHAPE_HERM,
		SHAPE_BEZI,
		SHAPE_LINE,
		SHAPE_STEP,
		SHAPE_BEZ2
	};

	float time_;
	SHAPE	shape_;
	float tension_;
	float continuity_;
	float bias_;
	float params_[4];
};

class KeyFloat : public KeyBase {
public:
	float value_;
};

class KeyQuaternion : public KeyBase {
public:
	Quaternion value_;
};

LEAVE_NAMESPACE

#endif
