/*
 *
 * Copyright (C) 2006 Mekensleep
 *
 *	Mekensleep
 *	24 rue vieille du temple
 *	75004 Paris
 *       licensing@mekensleep.com
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Authors:
 *  Igor Kravtchenko <igor@tsarevitch.org>
 *
 */

#ifndef UNDERWARE_VSERIAL_MATERIALSERIALIZER_H
#define UNDERWARE_VSERIAL_MATERIALSERIALIZER_H

#ifndef UNDERWARE_VSERIAL_USE_PCH
#include <vserial/vserial.h>
#endif

ENTER_NAMESPACE_UNDERWARE

class Material;
class DataOut;
class Pass;
class TextureLayer;
class TextureLayerBind;

class MaterialSerializer {
public:

	UW_VSERIAL_API static bool load(const char *fileName, Material **res = NULL);
	UW_VSERIAL_API static bool load(DataIn &data, Material **res = NULL);

	UW_VSERIAL_API static bool save(Material &mat, const char *fileName);
	UW_VSERIAL_API static bool save(Material &pat, DataOut &data);

protected:

	DataIn *in_;
	DataOut *out_;
	Material *material_;

	bool load();
	void save();

	// read functions
	bool readTECHchunk(Technique &tech, int chunkSize);
	bool readPASSchunk(Pass &pass, int chunkSize);
	bool readTEXLchunk(TextureLayer &tl, int chunkSize);

	// write functions
	void writeTECHchunk(Technique *tech);
	void writePASSchunk(Pass *pass);
	void writeTEXLchunk(TextureLayer *tl);
	void writeTEXBchunk(TextureLayerBind *tlb);
};

LEAVE_NAMESPACE

#endif // UNDERWARE_VSERIAL_MATERIALSERIALIZER_H
