/*
 *
 * Copyright (C) 2006 Mekensleep
 *
 *	Mekensleep
 *	24 rue vieille du temple
 *	75004 Paris
 *       licensing@mekensleep.com
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Authors:
 *  Igor Kravtchenko <igor@tsarevitch.org>
 *
 */

#ifndef UNDERWARE_VSERIAL_TEXTURELAYERBIND_H
#define UNDERWARE_VSERIAL_TEXTURELAYERBIND_H

#ifndef UNDERWARE_VSERIAL_USE_PCH
#include <vector>

#include <vserial/vserial.h>
#endif

ENTER_NAMESPACE_UNDERWARE

// Texel operations
enum TEXOP {
	TEXOP_REPLACE = 0,
	TEXOP_ADD = 1,
	TEXOP_MUL = 2,
	TEXOP_BLEND = 3,
	TEXOP_MUL2X = 4,
	TEXOP_PREVIOUSRGB_ALPHAMUL = 5, // keep the previous RGB value and modulate current Alpha with previous
	TEXOP_PREVIOUSRGB_ALPHADECAL = 6, // keep the previous RGB value and replace current Alpha
};

class TextureLayerBind {
	TextureLayerBind();
public:
	~TextureLayerBind();

	TEXOP getTexelOperation() const { return texop_; }
	void setTexelOperation(TEXOP texop) { texop_ =  texop; }

	float getOpacity() const { return opacity_; }
	void setOpacity(float opa) { opacity_ = opa; }

protected:
	TEXOP	texop_;
	float opacity_;

	friend class std::vector<TextureLayerBind>;
};

LEAVE_NAMESPACE

#endif // UNDERWARE_VSERIAL_TEXTURELAYERBIND_H

