/*
 *
 * Copyright (C) 2006 Mekensleep
 *
 *	Mekensleep
 *	24 rue vieille du temple
 *	75004 Paris
 *       licensing@mekensleep.com
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Authors:
 *  Igor Kravtchenko <igor@tsarevitch.org>
 *
 */

#ifndef UNDERWARE_VSERIAL_VECTOR3MAP_H
#define UNDERWARE_VSERIAL_VECTOR3MAP_H

#ifndef UNDERWARE_VSERIAL_USE_PCH
#include <map>
#include <vserial/vserial.h>
#include <vserial/vec3f.h>
#endif

#include <vserial/vertexmap.h>

ENTER_NAMESPACE_UNDERWARE

class Vector3Map : public VertexMap {

	Vector3Map(const std::string &name, MeshLayer &);
	virtual ~Vector3Map();

	int getNbEntries() const { return mapTable_.size(); }

public:
	std::map<unsigned short, Vec3f> mapTable_;

	friend class MeshLayer;
};


LEAVE_NAMESPACE

#endif
