/*
 *
 * Copyright (C) 2006 Mekensleep
 *
 *	Mekensleep
 *	24 rue vieille du temple
 *	75004 Paris
 *       licensing@mekensleep.com
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Authors:
 *  Igor Kravtchenko <igor@tsarevitch.org>
 *
 */

#ifndef UNDERWARE_VSERIAL_VERTEXMAP_H
#define UNDERWARE_VSERIAL_VERTEXMAP_H

#ifndef UNDERWARE_VSERIAL_USE_PCH
#include <vector>
#include <string>

#include <vserial/vserial.h>
#endif

ENTER_NAMESPACE_UNDERWARE

class MeshLayer;

enum VMAP_TYPE {
	VMAP_FLOAT = 0,	// one float32 per vertex to define values such as weights of vertices
	VMAP_VECTOR3 = 1,	// one vector3f per vertex to define values such as vertices translation for morphing or displacement
};

class VertexMap {

protected:

	VertexMap(const std::string &name, VMAP_TYPE, MeshLayer &);
	virtual ~VertexMap();

public:

	inline VMAP_TYPE getType() const { return type_; }
	inline MeshLayer* getMeshLayer() const { return layer_; }

	inline const std::string& getName() const { return name_; }
	inline void setName(const std::string &name) { name_ = name; }

	virtual int getNbEntries() const = 0;

protected:
	MeshLayer		*layer_;
	VMAP_TYPE	type_;
	std::string name_;

	friend class MeshLayer;
};

LEAVE_NAMESPACE

#endif
