/*
 *
 * Copyright (C) 2004-2006 Mekensleep
 *
 *	Mekensleep
 *	24 rue vieille du temple
 *	75004 Paris
 *       licensing@mekensleep.com
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Authors:
 *  Loic Dachary <loic@gnu.org>
 *
 */

#include "ugameStdAfx.h"

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifndef UGAME_USE_VS_PCH
#	include <ugame/ugameerror.h>
#endif

GQuark
underware_ugame_error_quark (void)
{
  static GQuark q = 0;
  if (q == 0)
    q = g_quark_from_static_string ("underware-ugame-error-quark");

  return q;
}

UGAMEError::UGAMEError(GError* error) : MAFError(error)
{
}

UGAMEError::UGAMEError(gint code, const gchar* format, ...) {
  va_list ap;
  va_start(ap, format);

  Init(UNDERWARE_UGAME_ERROR, code, format, ap);

  va_end(ap);
}

UGAMEError::UGAMEError(GQuark domain, gint code, const gchar* format, ...) {
  va_list ap;
  va_start(ap, format);

  Init(domain, code, format, ap);

  va_end(ap);
}

UGAMEError::~UGAMEError() {
}

