/*
 *
 * Copyright (C) 2006 Mekensleep
 *
 *	Mekensleep
 *	24 rue vieille du temple
 *	75004 Paris
 *       licensing@mekensleep.com
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Authors:
 *  Igor Kravtchenko <igor@tsarevitch.org>
 *
 */

#include <vserial/stdafx.h>

#ifndef UNDERWARE_VSERIAL_USE_PCH
#include <vserial/vserial.h>
#include <vserial/sceneitem.h>
#endif

ENTER_NAMESPACE_UNDERWARE

SceneItem::SceneItem(const std::string &_name) :
name_(_name),
position_(0, 0, 0),
quat_(0, 0, 0, 1),
scale_(1, 1, 1),
pivot_(0, 0, 0),
parent_(NULL),
motion_(NULL)
{ 
}

SceneItem::~SceneItem()
{
}

void SceneItem::addChild(SceneItem *_item)
{
	int nb = children_.size();
	for (int i = 0; i < nb; i++) {
		if (children_[i] == _item)
			return;
	}
	children_.push_back(_item);
	_item->parent_ = this;
}

void SceneItem::removeChild(SceneItem *_item)
{
	int nb = children_.size();
	for (int i = 0; i < nb; i++) {
		if (children_[i] == _item) {
			children_.erase( children_.begin() + i);
			_item->parent_ = NULL;
			return;
		}
	}
}

const std::string& SceneItem::getPropertyValueByKey(const std::string &_key) const
{
	std::map<std::string, std::string>::const_iterator it = properties_.begin();
	if (it == properties_.end())
		return "";

	return it->second;
}

LEAVE_NAMESPACE
